/// <reference types="node" />
import { Spawn } from '../interfaces/spawn';
import { ChildProcess } from 'child_process';
import { SpawnOptions2 } from "../custom-typings";
import { ForceErrorImpl } from "./force-error-impl";
import { CommandUtil } from "../interfaces/command-util";
export declare class SpawnImpl extends ForceErrorImpl implements Spawn {
    commandUtil: CommandUtil;
    private cachedPassword;
    constructor(commandUtil: CommandUtil);
    private validate_spawnShellCommandAsync_args(cmd, options, cbStatus, cbFinal, cbDiagnostic?);
    spawnShellCommandAsync(_cmd: string[], _options: SpawnOptions2, _cbStatus: (err: Error, result: string) => void, _cbFinal: (err: Error, result: string) => void, _cbDiagnostic?: (message: string) => void): ChildProcess;
    private static childCloseOrExit(code, signal, stdoutText, stderrText, options, cbFinal, cbDiagnostic);
    sudoSpawnAsync(cmd: string[], options: SpawnOptions2, cbStatus: (err: Error, result: string) => void, cbFinal: (err: Error, result: string) => void, cbDiagnostic?: (message: string) => void): ChildProcess;
}
