"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var child_process_1 = require("child_process");
var force_error_impl_1 = require("./force-error-impl");
var readlineSync = require('readline-sync');
var inpathSync = require('inpath').sync;
var psTree = require('ps-tree');
var SpawnImpl = (function (_super) {
    __extends(SpawnImpl, _super);
    function SpawnImpl(commandUtil) {
        var _this = _super.call(this) || this;
        _this.commandUtil = commandUtil;
        return _this;
    }
    SpawnImpl_1 = SpawnImpl;
    SpawnImpl.prototype.validate_spawnShellCommandAsync_args = function (cmd, options, cbStatus, cbFinal, cbDiagnostic) {
        if (cbDiagnostic === void 0) { cbDiagnostic = null; }
        var me = this;
        cmd = cmd || [];
        options = options || {};
        options.preSpawnMessage = options.preSpawnMessage || '';
        options.postSpawnMessage = options.postSpawnMessage || '';
        options.sudoUser = options.sudoUser || '';
        options.sudoPassword = options.sudoPassword || '';
        options.stdio = options.stdio || 'pipe';
        options.cwd = options.cwd || process.cwd();
        cbStatus = me.checkCallback(cbStatus);
        cbFinal = me.checkCallback(cbFinal);
        cbDiagnostic = cbDiagnostic || (function () {
        });
        return { cmd: cmd, options: options, cbStatus: cbStatus, cbFinal: cbFinal, cbDiagnostic: cbDiagnostic };
    };
    SpawnImpl.prototype.spawnShellCommandAsync = function (_cmd, _options, _cbStatus, _cbFinal, _cbDiagnostic) {
        if (_cbDiagnostic === void 0) { _cbDiagnostic = null; }
        var me = this;
        var _a = me.validate_spawnShellCommandAsync_args(_cmd, _options, _cbStatus, _cbFinal, _cbDiagnostic), cmd = _a.cmd, options = _a.options, cbStatus = _a.cbStatus, cbFinal = _a.cbFinal, cbDiagnostic = _a.cbDiagnostic;
        if (me.checkForceError('spawnShellCommandAsync', cbFinal)) {
            return;
        }
        var childProcess;
        try {
            var command = cmd[0];
            var args = cmd.slice(1);
            var stdoutText_1 = '';
            var stderrText_1 = '';
            if (!options.suppressDiagnostics) {
                cbDiagnostic("Running '" + cmd + "' @ '" + options.cwd + "'");
                options.preSpawnMessage && cbDiagnostic(options.preSpawnMessage);
            }
            childProcess = child_process_1.spawn(command, args, options);
            childProcess.stderr.on('data', function (dataChunk) {
                if (options.suppressStdErr && !options.cacheStdErr) {
                    return;
                }
                var text = dataChunk.toString();
                !options.suppressStdErr && cbStatus(new Error(text), text);
                options.cacheStdErr && (stderrText_1 += text);
            });
            childProcess.stdout.on('data', function (dataChunk) {
                if (options.suppressStdOut && !options.cacheStdOut) {
                    return;
                }
                var text = dataChunk.toString();
                !options.suppressStdOut && cbStatus(null, text);
                options.cacheStdOut && (stdoutText_1 += text);
            });
            childProcess.on('error', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code || 10, signal || '', stdoutText_1, stderrText_1, options, cbFinal, cbDiagnostic);
            });
            childProcess.on('exit', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, signal || '', stdoutText_1, stderrText_1, options, cbFinal, cbDiagnostic);
            });
            childProcess.on('close', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, signal || '', stdoutText_1, stderrText_1, options, cbFinal, cbDiagnostic);
            });
        }
        catch (err) {
            cbFinal && cbFinal(err, null);
        }
        return childProcess;
    };
    SpawnImpl.childCloseOrExit = function (code, signal, stdoutText, stderrText, options, cbFinal, cbDiagnostic) {
        if (cbFinal) {
            !options.suppressDiagnostics && options.postSpawnMessage && cbDiagnostic(options.postSpawnMessage);
            var returnString = JSON.stringify({ code: code, signal: signal, stdoutText: stdoutText, stderrText: stderrText }, undefined, 2);
            var error = (code !== null && code !== 0)
                ? new Error(returnString)
                : null;
            cbFinal(options.suppressFinalError ? null : error, options.suppressResult ? '' : returnString);
        }
        return null;
    };
    SpawnImpl.prototype.sudoSpawnAsync = function (cmd, options, cbStatus, cbFinal, cbDiagnostic) {
        if (cbDiagnostic === void 0) { cbDiagnostic = null; }
        var me = this;
        var prompt = '#node-sudo-passwd#';
        var prompts = 0;
        var args = ['-S', '-p', prompt];
        if (options.sudoUser) {
            args.unshift("--user=" + options.sudoUser);
        }
        cmd = cmd || [];
        cmd = cmd.slice(0);
        [].push.apply(args, cmd);
        var path = process.env['PATH'].split(':');
        var sudoBin = inpathSync('sudo', path);
        args.unshift(sudoBin);
        var child = me.spawnShellCommandAsync(args, options, function (err, result) {
            if (err && err.message === prompt) {
                return;
            }
            cbStatus(err, result);
        }, cbFinal);
        if (!child) {
            return;
        }
        function waitForStartup(err, children) {
            if (err) {
                throw new Error("Error spawning process");
            }
            if (children && children.length) {
                child.stderr.removeAllListeners();
            }
            else {
                setTimeout(function () {
                    psTree(child.pid, waitForStartup);
                }, 100);
            }
        }
        psTree(child.pid, waitForStartup);
        child.stderr.on('data', function (data) {
            var lines = data.toString().trim().split('\n');
            lines.forEach(function (line) {
                if (line === prompt) {
                    if (++prompts > 1) {
                        me.cachedPassword = null;
                    }
                    var username = require('username').sync();
                    var loginMessage = (prompts > 1)
                        ? "Sorry, try again.\n[sudo] password for " + username + ": "
                        : "[sudo] password for " + username + ": ";
                    if (!me.cachedPassword) {
                        me.cachedPassword = options.sudoPassword
                            ? options.sudoPassword
                            : readlineSync.question(loginMessage, { hideEchoBack: true });
                    }
                    child.stdin.write(me.cachedPassword + '\n');
                }
            });
        });
        return child;
    };
    SpawnImpl = SpawnImpl_1 = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('CommandUtil')),
        __metadata("design:paramtypes", [Object])
    ], SpawnImpl);
    return SpawnImpl;
    var SpawnImpl_1;
}(force_error_impl_1.ForceErrorImpl));
exports.SpawnImpl = SpawnImpl;
//# sourceMappingURL=spawn-impl.js.map